<template>
<body>
  <div id="test">
    <div class="head-link">
      <router-link class="ellink" :to="{ name: `NN${authType === 0 ? 'Student' : 'Teacher'}ClassIndex` }">
      <el-card class="link" shadow="hover">
        <i class="el-icon-s-platform"></i>
        <div class="link-box" >
          <h1>{{ authType === 0 ? $t('HEADER.STUDYING_CLASSES') : $t('HEADER.TEACHING_CLASSES') }}</h1> <!--강의중인 과목 -->
          <div class="link-title-num" :key="classNum" >{{ classNum }}</div>
        </div>
      </el-card>
      </router-link>
      <router-link class="ellink" to="/v4/test2/test2Assignment">
      <el-card  class="link" shadow="hover">
        <i class="el-icon-document"></i>
        <div class="link-box">
          <h1>{{ $t('HEADER.TASK_PROGRESS') }}</h1> <!--진행중인 과제-->
          <div class="link-title-num" >{{boards.length}}</div>
        </div>
      </el-card>
      </router-link>
    </div>
    <div class="head-notice-QnA">
      <el-card class="notice-qna" shadow="hover">
        <div class="notice-qna-top">
          <i class="el-icon-message-solid">{{ $t('CLASS_MENU.NOTICE') }}</i>
          <div class="showMore"><router-link class="href" :to="{ name: 'v4_test2/test2Notice', params: { classId: 0, className: 'Home'}}">{{ $t("LANDING.SHOW_MORE") }}</router-link></div>
        </div>
        <div>
          <ul>
            <li v-for="notice in notices" :key="notice.noticeId">
              <router-link class="href" :to="{ name: 'NNClassNoticeDetail', params: { classId: notice.classId,noticeId: notice.noticeId}}">{{ `${notice.className} ${notice.name}` }}</router-link>
            </li>
            <li>...</li>
          </ul>
        </div>
      </el-card>
      <el-card class="notice-qna" shadow="hover">
        <div class="notice-qna-top">
          <i class="el-icon-s-order"> {{ $t('CLASS_MENU.BOARD') }} </i>
          <div class="showMore"><router-link class="href" :to="{ name: 'v4_test2/test2Board', params: { classId: 0, className: 'Home'}}">{{ $t("LANDING.SHOW_MORE") }}</router-link></div>
        </div>
        <div>
          <ul>
            <li v-for="board in boardsRecent" :key="board.board_id">
              <router-link class="href" :to="{ name: 'NNClassQuestionDetail', params: { classId: board.classId, boardId: board.boardId }}">{{ `${board.className} ${board.name}` }}</router-link>
            </li>
            <li>...</li>
          </ul>
        </div>
      </el-card>
    </div>
    </div>
</body>
</template>

<script>
import { mapState, mapActions } from 'vuex';
import classService from '../../services/classService';
import utils from '../../utils';

export default {
  computed: {
    ...mapState('auth', ['jwt']),
    ...mapState('NNclass', [
        'teachingClassList',
      ]),
      authName() {
        const vm = this;
        const jwt = vm.$store.state.auth.jwt;
        return utils.getNameFromJwt(jwt);
      },
      authType() {
        const vm = this;
        const jwt = vm.$store.state.auth.jwt;
        return utils.getAuthTypeFromJwt2(jwt);
      },
      boardsRecent() {
        const vm = this;
        return vm.boards.slice(0, 5);
    },  
    classNum() {
      const vm = this;
      return vm.classes ? (vm.authType === 0 ? vm.classes.studyingClasses.length : vm.classes.teachingClasses.length) : 0;
    }
  },
  methods: {
    ...mapActions('NNclass', [
      'getClassLists',
      'getMyClassLists',
      'deleteClassUser',
    ]),
    showAllBoards(){
      this.showAllBoard = true
      const vm = this;
      this.showAllBoard;
      
      vm.boardShowNumber = 5;
    },
    getFormatDate(date){
      var year = date.getFullYear();              //yyyy
      var month = (1 + date.getMonth());          //M
      month = month >= 10 ? month : '0' + month;  //month 두자리로 저장
      var day = date.getDate();                   //d
      day = day >= 10 ? day : '0' + day;          //day 두자리로 저장
      return  year + '년 ' + month + '월 ' + day +'일';       //'-' 추가하여 yyyy-mm-dd 형태 생성 가능
    },
  },
  data() {
    return {
      lectureNum: 0,
      boards: [],
      boardShowNumber: 5,
      notices: [],
      classes: null,
    }
  },

  async mounted() {
    const vm = this;
    const result = await Promise.all([classService.getMyClassList(), classService.getMyBoards(), classService.getMyNotices()]);
    vm.classes = result[0].data;
    vm.boards = result[1].data.boards.map(board => ({
      className: board.class.name,
      name: board.name,
      content: board.content,
      date: this.getFormatDate(new Date(board.created_at)),
      dateSort: new Date(board.created_at),
      classId: board.class_id,
      boardId: board.board_id,
    })).sort((a, b) => {
        return b.dateSort - a.dateSort;
    });
    vm.notices = result[2].data.notices.map(notices => ({
      className: notices.class.name,
      name: notices.name,
      content: notices.content,
      date: this.getFormatDate(new Date(notices.created_at)),
      dateSort: new Date(notices.created_at),
      noticeId: notices.notice_id,
      classId: notices.class_id,
    })).sort((a, b) => {
        return a.dateSort - b.dateSort;
    }).slice(0, 5);
  },
};
</script>

<style scoped>

#test{
  width:82.6%;
  height:100%;
}
.head-link{
    display: -webkit-box;
    left: 100px;
    top: 151px;
    position: relative;
} 

.link{ 
    display: -webkit-box;
    width: 485px;
    height: 137px;
    margin: 10px;
    border: 1px solid rgba(67,102,172,0.2);
    border-radius: 10px;
    background-color: #FFFFFF;  
}
.ellink{
  display: -webkit-box;
  text-decoration: none;
}

.head-link i {
    font-size: 50px;
    padding: 24px 63px 23px 67px ;
    float: left;
}
/* .el-card__body{} */

.link-box {
    height:137px;
    width: 269px;
    margin: -25px 0px 0px 148px;
    font-family: "Apple SD Gothic Neo";
    font-weight: bold;
}


.link-box h1 {
    margin-top: 42px;
    margin-bottom: 9px;
    font-size: 20px;
    letter-spacing: -0.07px;
}

.link-title-num {
    display: inline;
    font-size: 38px;
    letter-spacing: -0.13px;

}

.head-notice-QnA{
    display: -webkit-box;
    left: 100px;
    top: 200px;
    position: relative;
}
.notice-qna{
    width: 485px;
    height: 217px;
    margin: 10px;
    border: 1px solid rgba(67,102,172,0.2);
    border-radius: 10px;
    background-color: #FFFFFF;
}

.notice-qna-top{
    display: flex;
    justify-content: space-between;
    padding: 12px 32px;
}

.notice-qna-top i{
    font-family: "Apple SD Gothic Neo";
    font-size: 20px;
    font-weight: bold;
}

.notice-qna-top a{ 
    color: #393B3F;
    font-family: "Apple SD Gothic Neo";
    font-size: 14px;
    font-weight: bold;
    letter-spacing: -0.05px;
    line-height: 17px;
    text-align: center;
}

.notice-qna-body{
    color: #393B3F;
    font-family: "Lucida Grande";
    font-size: 14px;
    letter-spacing: -0.05px;
    line-height: 17px;
}

ul {
  margin: 0;
}

.href{
  text-decoration: none;
  color: black;
  font-size: 14px;
}

.notice-qna li {
    list-style: none;
}

.notice-qna>a{
    height: 24px;
    width: 41px;
    color: #393B3F;
    font-family: "Apple SD Gothic Neo";
    font-size: 20px;
    font-weight: bold;
    letter-spacing: -0.07px;
    line-height: 24px;
    text-align: center;
}
.head-study{
    left: 50px;
    top: 50px;
    position: relative;
}

.showMore {
  font-size: 14px;
  cursor: pointer;
}

.head-study>p{ 
    color: #232323;
    font-family: "Apple SD Gothic Neo";
    font-size: 20px;
    font-weight: bold;
    letter-spacing: -0.07px;
    line-height: 24px;
    text-align: left;
}

.study{ 
    width: 992px;
    height: 90px;
    margin: 20px;
    border: 1px solid rgba(67,102,172,0.2);
    border-radius: 10px;
    background-color: #FFFFFF;
}

.study-title{
    width: 317px;
    height: 90px;
    background-color: rgba(67,102,172,0.06);
    font-size:16px ;
    float: left;
}

.study-title h1 {
    margin: 0;
    font-size: 16px;
    padding: 25px 0px 0px 34px;
    
}

.study-title h2 {
    font-size: 14px;
    padding: 0px 0px 0px 32px;
    
}

.study-body { 
    display: flex;
}

.progress {
    width: 289px;
    margin: 0px;
    top: 0px;
    left: 0px;
    position: relative;
}

.study-body h1{
    font-size: 14px;
    margin: 0;
    top: 26px;
    left: 20px;
    position: relative;
}

.study-btn {
    font-size: 14px ;
    padding: 13px 20px ;
    margin: 0px ;
    background: #4366ac ;
    color: #fff ;
    left: 235px; 
    top: 34px;
    position: relative;
    border-radius: 4px;
}
.pagination {
  text-align: center;
}

</style>
